SystemOrganization addCategory: #Estanciero!

TestCase subclass: #TestsEstanciero
	instanceVariableNames: 'apo fede agus banco tablero salida formosa zonaSurF zonaCentroF zonaNorteF premioGanadero empresaPetrolera salta zonaSurS zonaCentroS zonaNorteS bodega tucuman zonaSurT zonaNorteT fabrica cordoba zonaSurC zonaCentroC zonaNorteC juego prision'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'Federico 10/14/2012 21:09'!
setUp 
	
	apo := Participante new.
	apo estrategia: Standard new.  
	apo dinero: 50000.
	
	fede := Participante new.
	fede estrategia: Standard new.  
	fede dinero: 10000.
	
	agus := Participante new.
	banco := Banco new.
	
	tablero := Tablero new.
	tablero banco: banco.
	
	prision := Prision new.
	prision tablero: tablero.
	
	salida := Salida new.
	salida tablero: tablero.
	
	formosa := Provincia new.
	formosa tablero: tablero.
	
	zonaSurF := Campo unCampoEn: formosa conPrecio: 1000 conValorRenta: 500 conUnCostoDeConstruccionDeEstancia: 500.

	zonaCentroF := Campo unCampoEn: formosa conPrecio: 1000 conValorRenta: 500 conUnCostoDeConstruccionDeEstancia: 250.

	zonaNorteF := Campo unCampoEn: formosa conPrecio: 1200 conValorRenta: 600 conUnCostoDeConstruccionDeEstancia: 300.

	premioGanadero := Premio new.
	premioGanadero tablero: tablero.

	empresaPetrolera := EmpresaConRentaFija new.
	empresaPetrolera tablero: tablero.
	empresaPetrolera precio: 380.
	empresaPetrolera rentaFija: 200.
	empresaPetrolera dueo: banco.

	salta := Provincia new.
	salta tablero: tablero.

	zonaSurS := Campo unCampoEn: salta conPrecio: 2600 conValorRenta: 800 conUnCostoDeConstruccionDeEstancia: 300.
	
	zonaCentroS := Campo unCampoEn: salta conPrecio: 2600 conValorRenta: 850 conUnCostoDeConstruccionDeEstancia: 300.

	zonaNorteS := Campo unCampoEn: salta conPrecio: 3000 conValorRenta: 900 conUnCostoDeConstruccionDeEstancia: 350.

	bodega := EmpresaConRentaFija new.
	bodega tablero: tablero.
	bodega precio: 380.
	bodega rentaFija: 150.
	bodega dueo: banco.

	tucuman := Provincia new.
	tucuman tablero: tablero.

	zonaSurT := Campo unCampoEn: tucuman conPrecio: 5000 conValorRenta: 1000 conUnCostoDeConstruccionDeEstancia: 400.

	zonaNorteT := Campo unCampoEn: tucuman conPrecio: 5400 conValorRenta: 1200 conUnCostoDeConstruccionDeEstancia: 500.
	
	fabrica := EmpresaConRentaFija new.
	fabrica tablero: tablero.
	fabrica precio: 380.
	fabrica rentaFija: 150.
	fabrica dueo: banco.

	cordoba := Provincia new.
	cordoba tablero: tablero.

	zonaSurC := Campo unCampoEn: cordoba conPrecio: 6000 conValorRenta: 1500 conUnCostoDeConstruccionDeEstancia: 800.

	zonaCentroC := Campo unCampoEn: cordoba conPrecio: 6000 conValorRenta: 1500 conUnCostoDeConstruccionDeEstancia: 800.

	zonaNorteC:= Campo unCampoEn: cordoba conPrecio: 6400 conValorRenta: 1500 conUnCostoDeConstruccionDeEstancia: 900.

	juego := Juego new.
	juego tablero: tablero.
	juego agregarJugadores: apo.
	juego agregarJugadores: fede.

	apo tablero: tablero.  
	apo agregarPropiedades: zonaSurT.
	apo agregarPropiedades: zonaNorteT.
	apo agregarPropiedades: zonaSurF.
	zonaNorteT cantidadEstancias: 1.

	fede tablero: tablero.
	fede agregarPropiedades: zonaSurC.
	fede agregarPropiedades: zonaCentroC.
	fede agregarPropiedades: zonaNorteC.
	fede agregarPropiedades: zonaCentroF.
	fede agregarPropiedades: bodega.
	fede agregarPropiedades: empresaPetrolera.! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 17:29'!
testAlConsultarLosDueosDeFormosaDevuelveApoFedeYBanco
	
	|dueosDeFormosa|
	dueosDeFormosa := formosa dueos.
	self assert: ((dueosDeFormosa includes: apo) and: [(dueosDeFormosa includes: fede) and: [dueosDeFormosa includes: banco]] ).! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 17:32'!
testAlConsultarLosDueosDeTucumanDevuelveApo
	
	|dueosDeTucuman|
	dueosDeTucuman := tucuman dueos.
	self assert: (dueosDeTucuman allSatisfy: [:dueo | dueo=apo]).! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 18:38'!
testApoCompraLaFabricaYAlConsultarLaRentaParaFedeDevuelveUnNumeroEntre60000Y360000

	apo comprar: fabrica.
	self assert: ((60000 to: 360000) includes: (fabrica rentaPara: fede)).     ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 21:21'!
testApoConstruyeEstanciaEnZonaSurTucumanSuDineroPasaASer49600YElCampoPasaATenerUnaEstancia

	zonaSurT agregarEstanciaDe: apo.
	self assert: (apo dinero = 49600 and: [zonaSurT cantidadEstancias = 1]).    ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 21:27'!
testApoIntentaAgregarEstanciaEnZonaCentroFormosaYSeLanzaErrorYSuDineroYLaCantidadDeEstanciasDelCampoQuedanIntactas

	|dineroAnterior cantEstanciasAnterior|
	
	dineroAnterior := apo dinero.
	cantEstanciasAnterior := zonaCentroF cantidadEstancias.
	self should: [zonaCentroF agregarEstanciaDe: apo.] raise: NoSePuedeConstruirEstanciaError.   
	self assert: (apo dinero = dineroAnterior and: [zonaSurT cantidadEstancias = cantEstanciasAnterior]).
	    ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 21:31'!
testApoIntentaConstruirEstanciaEnZonaNorteTucumanYSaltaError

	self should: [zonaNorteT agregarEstanciaDe: apo.] raise: NoSePuedeConstruirEstanciaError.   
	
	    ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 21:12'!
testApoLePaga10000AFedeYFedeAumentaSuDineroA20000YAApoLeQuedan40000.

	apo paga: 10000 a: fede.
	self assert: (fede dinero = 20000 and: [apo dinero = 40000]).     ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 17:52'!
testApoPasaPorLaZonaCentroDeFormosaYElYFedeMantieneSuDinero

	|dineroAnteriorFede dineroAnteriorApo|
	
	dineroAnteriorApo := apo dinero.
	dineroAnteriorFede := fede dinero.
	zonaCentroF paso: apo.
	self assert: (dineroAnteriorApo = apo dinero and: [dineroAnteriorFede = fede dinero]).    ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 18:45'!
testConsultarLaRentaDeLaBodegaParaApoYDevuelveEntre120000Y720000

	self assert: ((120000 to: 720000) includes: (bodega rentaPara: apo)).       
	   ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 18:30'!
testConsultarLaRentaDeLaZonaNorteDeTucumanParaFedeYDevuelve2400

	self assert: ((zonaNorteT rentaPara: fede) = 2400).    
	
	      ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 18:29'!
testConsultarLaRentaDeLaZonaSurDeTucumanParaFedeYEs1000

	self assert: ((zonaSurT rentaPara: fede) = 1000).    
	
	      ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 17:02'!
testFedeCaeEnLaPrisionYMantieneSusPropiedadesSuDineroYSigueLibre

	|dineroAnterior propiedadesAnterirores|
	
	dineroAnterior := fede dinero.
	propiedadesAnterirores := fede propiedades.
	prision cayo: fede.  
	self assert: (fede dinero = dineroAnterior and: [propiedadesAnterirores == fede propiedades and: [fede estasLibre ]]  ).     
	   ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 17:39'!
testFedeCaeEnLaSalidaYSuDineroPasaASer10000

	salida cayo: fede.
	self assert: (fede dinero = 10000).    ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 18:00'!
testFedeCaeEnLaZonaCentroDeFormosaYSuDineroNoSeModifica

	|dineroAnterior|
	
	dineroAnterior := fede dinero.
	zonaCentroF cayo: fede.  
	self assert: (dineroAnterior = fede dinero).     
	   ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 18:07'!
testFedeCaeEnLaZonaSurDeSaltaYLaCompraYSuDineroPasaASer7400

	zonaSurS cayo: fede.
	self assert: ((fede propiedades includes: zonaSurS) and: [fede dinero = 7400]).      
	   ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 18:14'!
testFedeCaeEnLaZonaSurDeTucumanFedePasaATener9000yApo51000
	
	zonaSurT cayo: fede.
	self assert: (fede dinero = 9000 and: [apo dinero = 51000]) .      
	   ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 17:38'!
testFedeCaeEnPremioGanaderoYSuDineroPasaASer12500

	premioGanadero cayo: fede.
	self assert: (fede dinero = 12500).    ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 16:54'!
testFedeEStaPresoHace3TurnosYSaqueLoQueSaqueEstaLibre

	fede ponetePreso.
	fede cantidadTurnosPreso:3.
	fede saco: 1 y: 6 .
	fede estado jugo: fede saco: 7.         
	self assert: (fede estasLibre).     
	   ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 18:26'!
testFedeEstaEnPremioGanaderoYJuegaYEstaEnOtroCasillero

	|numeroDado  casilleros |
	fede posicionEnTablero: premioGanadero .
	numeroDado := fede tirarDados.
	[fede estado jugo: fede saco: numeroDado .] on: EstasEnBancarrotaError do: [:e | self jugadores remove: fede .].
	self assert: (fede posicionEnTablero ~= premioGanadero )  	
	
	      ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 16:45'!
testFedeEstaPresoHace1TurnoSaca4Y5YSiguePreso

	fede ponetePreso.
	fede cantidadTurnosPreso: 1.
	fede saco: 4 y: 5.
	fede estado jugo: fede saco: 9. 
	self assert: (fede estasPreso).     
	   ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 16:46'!
testFedeEstaPresoHace1TurnoSacaDoble3YEstaLibre

	fede ponetePreso.
	fede cantidadTurnosPreso: 1.
	fede saco: 3 y: 3.
	fede estado jugo: fede saco: 6. 
	self assert: (fede estasLibre).     
	   ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 17:02'!
testFedePasaPorLaPrisionYMantieneSusPropiedadesSuDineroYSigueLibre

	|dineroAnterior propiedadesAnterirores|
	
	dineroAnterior := fede dinero.
	propiedadesAnterirores := fede propiedades.
	prision paso: fede.  
	self assert: (fede dinero = dineroAnterior and: [propiedadesAnterirores == fede propiedades and: [fede estasLibre ]]  ).     
	   ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 17:45'!
testFedePasaPorLaSalidaYSuDineroEs15000

	salida paso: fede.
	self assert: (fede dinero = 15000).    ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 17:40'!
testFedePasaPorPremioGanaderoYMantieneSuDinero

	|dineroAnterior|
	dineroAnterior := fede dinero.
	premioGanadero paso: fede.
	self assert: (fede dinero = dineroAnterior).    ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 16:39'!
testFedeSacaDoble2YLuegoSaca4y5YNoEstaPreso

	fede saco: 2 y: 2.
	fede estado jugo: fede saco: 4.   
	fede saco: 4 y: 5.
	fede estado jugo: fede saco: 9.
	self deny: (fede estasPreso).     
	   ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 16:41'!
testFedeSacaDoble2YLuegoSacaDoble4YEstaPreso

	fede saco: 2 y: 2.
	fede estado jugo: fede saco: 4.   
	fede saco: 4 y: 4.
	fede estado jugo: fede saco: 8.
	self assert: (fede estasPreso).     
	   ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 18:21'!
testFedeSeMuevePorZonaCentroDeCordobaSalidaYZonaSurDeFormosaSuDineroPasaASer14500YQuedaEnZonaSurDeFormosa

	|casilleros|
	
	casilleros := OrderedCollection new.
	casilleros add: zonaNorteC .
	casilleros add: salida .
	casilleros add: zonaSurF.
	
	fede moveteUnos: casilleros.
	self assert: (fede dinero = 14500 and: [fede posicionEnTablero = zonaSurF]).        ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 17:36'!
testLaCantidadDeEmpresasDeFedeEs2

	self assert: (fede cantidadEmpresas = 2).    ! !

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 17:55'!
testUnaTiradaDeDadosDaEntre2Y12

	self assert: ((2 to: 12) includes: fede tirarDados).    ! !

Object subclass: #Casillero
	instanceVariableNames: 'tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Casillero methodsFor: 'as yet unclassified' stamp: 'Federico 9/8/2012 10:56'!
cayo: unJugador
	"Si el casillero no entendio antes que hacer no tiene que hacer nada"! !

!Casillero methodsFor: 'as yet unclassified' stamp: 'Federico 9/8/2012 10:56'!
paso: unJugador
	"Si el casillero no entendio antes que hacer no tiene que hacer nada"! !

!Casillero methodsFor: 'getter' stamp: 'Federico 9/3/2012 21:02'!
tablero
	^tablero.! !

!Casillero methodsFor: 'setter' stamp: 'Federico 9/6/2012 22:23'!
tablero: tableroActual
	tablero := tableroActual.
	tableroActual agregarCasilleros: self.! !

Casillero subclass: #Premio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Premio methodsFor: 'as yet unclassified' stamp: 'Apo 9/6/2012 16:08'!
cayo: jugador
	jugador recibe: 2500.! !

Casillero subclass: #Prision
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

Casillero subclass: #Propiedad
	instanceVariableNames: 'precio dueo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

Propiedad subclass: #Campo
	instanceVariableNames: 'provincia valorRenta costoConstruccionEstancia cantidadEstancias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Campo class methodsFor: 'as yet unclassified' stamp: 'Federico 10/9/2012 14:55'!
unCampoEn: unaProvincia conPrecio: unPrecio conValorRenta: unaRenta conUnCostoDeConstruccionDeEstancia: unCosto
	| nuevoCampo |
	nuevoCampo := Campo new.
	nuevoCampo provincia: unaProvincia.
	nuevoCampo dueo: unaProvincia tablero banco. "Hace que cada campo tome como dueo al banco del tablero en el que esta su provincia"
	unaProvincia tablero banco agregarPropiedades:  nuevoCampo. "Agrega el campo a las propiedades del banco"
	nuevoCampo tablero: unaProvincia tablero. "Hace que el casillero entienda cual es su tablero"
	nuevoCampo precio: unPrecio.
	nuevoCampo valorRenta: unaRenta.
	nuevoCampo costoConstruccionEstancia: unCosto.
	^nuevoCampo.! !

!Campo methodsFor: 'getter' stamp: 'Federico 9/18/2012 10:35'!
agregarEstanciaDe: jugador
	self provincia verificaConstruccionEn:  self .
	jugador comprarEstanciaEn: self. 
	self cantidadEstancias: self cantidadEstancias + 1. ! !

!Campo methodsFor: 'getter' stamp: 'Apo 9/6/2012 19:02'!
cantidadEstancias
	^cantidadEstancias.! !

!Campo methodsFor: 'setter' stamp: 'Apo 9/6/2012 19:01'!
cantidadEstancias: unaCantEstancias
	cantidadEstancias := unaCantEstancias. ! !

!Campo methodsFor: 'getter' stamp: 'Federico 9/3/2012 23:15'!
costoConstruccionEstancia
	^costoConstruccionEstancia.! !

!Campo methodsFor: 'setter' stamp: 'Federico 9/3/2012 23:15'!
costoConstruccionEstancia: costoActual
	costoConstruccionEstancia := costoActual.! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Federico 9/11/2012 05:25'!
initialize 
	cantidadEstancias := 0.! !

!Campo methodsFor: 'getter' stamp: 'Federico 9/3/2012 21:19'!
provincia
	^provincia.! !

!Campo methodsFor: 'setter' stamp: 'Federico 10/9/2012 15:04'!
provincia: provinciaActual
	provincia := provinciaActual.
	provinciaActual agregarCampos: self. "Le dice a la provincia que tiene un campo nuevo para agregar"! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Apo 9/6/2012 19:44'!
renta: cantEstancias
	^(2 raisedTo:  cantEstancias) * valorRenta.! !

!Campo methodsFor: 'setter' stamp: 'Federico 9/15/2012 20:05'!
rentaPara: jugador
	^self renta: self cantidadEstancias.! !

!Campo methodsFor: 'getter' stamp: 'Federico 9/3/2012 23:14'!
valorRenta
	^valorRenta.! !

!Campo methodsFor: 'setter' stamp: 'Federico 9/3/2012 23:14'!
valorRenta: rentaActual
	valorRenta := rentaActual.! !

Propiedad subclass: #Empresa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Empresa methodsFor: 'as yet unclassified' stamp: 'Federico 9/6/2012 21:12'!
renta: numeroDado
	^numeroDado * 30000 * self dueo cantidadEmpresas.! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 17:53'!
rentaPara: jugador
	^self renta: (jugador tirarDado + jugador tirarDado).! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'Federico 9/4/2012 11:18'!
sosEmpresa
	^true.! !

Empresa subclass: #EmpresaConRentaFija
	instanceVariableNames: 'rentaFija'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!EmpresaConRentaFija methodsFor: 'as yet unclassified' stamp: 'Federico 9/15/2012 20:18'!
rentaFija 
	^rentaFija.! !

!EmpresaConRentaFija methodsFor: 'as yet unclassified' stamp: 'Federico 9/15/2012 20:18'!
rentaFija: rentaActual
	rentaFija := rentaActual.! !

!EmpresaConRentaFija methodsFor: 'as yet unclassified' stamp: 'Federico 9/15/2012 20:17'!
rentaPara: jugador
	^self rentaFija.! !

!Propiedad methodsFor: 'getter' stamp: 'Federico 9/18/2012 10:44'!
cayo: jugador
	(self dueo ~= jugador) ifTrue: [self dueo teVisito: jugador en: self.].! !

!Propiedad methodsFor: 'getter' stamp: 'Federico 9/3/2012 19:08'!
dueo
	^dueo.! !

!Propiedad methodsFor: 'setter' stamp: 'Federico 9/3/2012 19:08'!
dueo: nuevoDueo
	dueo := nuevoDueo.! !

!Propiedad methodsFor: 'setter' stamp: 'Federico 10/9/2012 14:46'!
hipotecate
	self precio: self precio * 1,5.
	self dueo: self tablero banco .
	! !

!Propiedad methodsFor: 'getter' stamp: 'Federico 9/3/2012 19:09'!
precio
	^precio.! !

!Propiedad methodsFor: 'setter' stamp: 'Federico 9/3/2012 19:09'!
precio: nuevoPrecio
	precio := nuevoPrecio.! !

!Propiedad methodsFor: 'setter' stamp: 'Federico 9/17/2012 19:09'!
sosEmpresa
	^false.! !

Casillero subclass: #Salida
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Salida methodsFor: 'as yet unclassified' stamp: 'Federico 9/11/2012 21:56'!
paso: unJugador
	unJugador recibe: 5000.! !

Object subclass: #Garca
	instanceVariableNames: 'campos tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Garca methodsFor: 'as yet unclassified' stamp: 'Federico 10/3/2012 17:10'!
queresQue: unJugador Compre: unaPropiedad
	| propiedades |
	unaPropiedad sosEmpresa 
		ifTrue: 
			[ propiedades := unaPropiedad tablero empresas  .] 
		ifFalse: 
			[ propiedades := unaPropiedad provincia propiedades .].
		^propiedades anySatisfy: [:propiedad | (propiedad dueo ~= unaPropiedad dueo) | (propiedad dueo ~= unJugador) .].! !

Object subclass: #Imperialista
	instanceVariableNames: 'campos tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Imperialista methodsFor: 'as yet unclassified' stamp: 'Federico 10/3/2012 17:18'!
queresQue: unJugador Compre: unaPropiedad
	| propiedades  |
	unaPropiedad sosEmpresa 
		ifTrue: 
			[ ^unaPropiedad tablero empresas allSatisfy: [:propiedad | propiedad dueo = unaPropiedad dueo .] .] 
		ifFalse: 
			[ propiedades := unaPropiedad provincia propiedades .
			^ (propiedades anySatisfy: [:propiedad | propiedad dueo = unJugador .]) | (propiedades allSatisfy: [:propiedad | propiedad dueo = unaPropiedad dueo .]) .]! !

Object subclass: #Juego
	instanceVariableNames: 'jugadores tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Juego methodsFor: 'as yet unclassified' stamp: 'Federico 9/8/2012 10:57'!
agregarJugadores: jugadorNuevo
	jugadores add: jugadorNuevo.
	jugadorNuevo posicionEnTablero: self tablero casilleros first.  "Pone el jugador nuevo en la salida (primer casillero del tablero)"! !

!Juego methodsFor: 'as yet unclassified' stamp: 'AgustinCroce 10/13/2012 16:36'!
casillerosPara: unJugador con: numeroDado
	^self tablero casillerosDesde: unJugador posicionEnTablero hasta: numeroDado. ! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Federico 9/11/2012 05:20'!
initialize
	jugadores := OrderedCollection new.! !

!Juego methodsFor: 'getter' stamp: 'Federico 9/3/2012 20:55'!
jugadores
	^jugadores.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Federico 10/3/2012 18:29'!
queJuegue: unJugador
	|numeroDado  casilleros |
	numeroDado := unJugador tirarDados.
	[unJugador estado jugo: unJugador saco: numeroDado .] on: EstasEnBancarrotaError do: [:e | self jugadores remove: unJugador .].	
	self queJuegueElQueSigue.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Federico 9/3/2012 19:20'!
queJuegueElQueSigue
	| elQueSigue |
	elQueSigue := self jugadores add: self jugadores removeFirst.
	self queJuegue: elQueSigue.! !

!Juego methodsFor: 'getter' stamp: 'Federico 9/6/2012 22:16'!
tablero
	^tablero.! !

!Juego methodsFor: 'setter' stamp: 'Federico 9/6/2012 22:16'!
tablero: tableroActual
	tablero := tableroActual.! !

Object subclass: #Jugador
	instanceVariableNames: 'propiedades tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

Jugador subclass: #Banco
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Banco methodsFor: 'as yet unclassified' stamp: 'Federico 9/8/2012 10:50'!
recibe: unDinero 
	"El banco no recibe plata ya que su dinero es infinito"! !

!Banco methodsFor: 'as yet unclassified' stamp: 'Federico 10/3/2012 16:56'!
teVisito: jugador en: propiedad
	( jugador estrategia queresQue: jugador Compre: propiedad ) ifTrue: [ jugador comprar: propiedad .].! !

!Jugador methodsFor: 'accessing' stamp: 'Federico 9/17/2012 21:43'!
agregarPropiedades: nuevaPropiedad
	propiedades add: nuevaPropiedad.
	nuevaPropiedad dueo: self.! !

!Jugador methodsFor: 'accessing' stamp: 'Federico 9/17/2012 21:43'!
initialize
	propiedades := OrderedCollection new.! !

!Jugador methodsFor: 'getter' stamp: 'Federico 9/17/2012 21:43'!
propiedades 
	^propiedades.! !

!Jugador methodsFor: 'getter' stamp: 'Federico 10/3/2012 16:22'!
tablero
	^tablero! !

!Jugador methodsFor: 'setter' stamp: 'Federico 10/3/2012 16:22'!
tablero: tableroActual
	tablero := tableroActual.! !

Jugador subclass: #Participante
	instanceVariableNames: 'dinero posicionEnTablero cantidadDeDoble cantidadTurnosPreso estado estrategia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Participante methodsFor: 'accessing' stamp: 'Federico 9/17/2012 21:16'!
avanzarPor: casilleros 
	casilleros do: [ : unCasillero | unCasillero paso: self].! !

!Participante methodsFor: 'accessing' stamp: 'Federico 9/17/2012 21:18'!
caerEn: casillero
	casillero cayo: self.
	self posicionEnTablero: casillero.! !

!Participante methodsFor: 'getter' stamp: 'AgustinCroce 10/13/2012 16:15'!
cantidadDeDoble 

	^cantidadDeDoble ! !

!Participante methodsFor: 'setter' stamp: 'AgustinCroce 10/13/2012 16:14'!
cantidadDeDoble: unNumero

	cantidadDeDoble := unNumero .! !

!Participante methodsFor: 'accessing' stamp: 'Federico 9/22/2012 05:35'!
cantidadEmpresas
	^self propiedades count: [:propiedad | propiedad sosEmpresa. ].! !

!Participante methodsFor: 'getter' stamp: 'Federico 10/3/2012 16:30'!
cantidadTurnosPreso
	^cantidadTurnosPreso! !

!Participante methodsFor: 'setter' stamp: 'Federico 10/3/2012 16:31'!
cantidadTurnosPreso: cantidadPresoActual
	cantidadTurnosPreso := cantidadPresoActual.! !

!Participante methodsFor: 'setter' stamp: 'Federico 10/3/2012 16:16'!
casillerosPara: numeroDado
	^self tablero casillerosDesde: self posicionEnTablero hasta: numeroDado. ! !

!Participante methodsFor: 'accessing' stamp: 'Federico 9/17/2012 21:09'!
comprar: propiedad
	self pagar: propiedad precio.
	self agregarPropiedades: propiedad.! !

!Participante methodsFor: 'accessing' stamp: 'Federico 9/17/2012 21:10'!
comprarEstanciaEn: campo
	self pagar: campo costoConstruccionEstancia . ! !

!Participante methodsFor: 'getter' stamp: 'Federico 9/3/2012 19:11'!
dinero
	^dinero.! !

!Participante methodsFor: 'setter' stamp: 'Federico 9/3/2012 19:11'!
dinero: dineroActual
	dinero := dineroActual.! !

!Participante methodsFor: 'getter' stamp: 'Federico 10/3/2012 16:32'!
estado
	^estado! !

!Participante methodsFor: 'setter' stamp: 'Federico 10/3/2012 16:32'!
estado: estadoActual
	estado := estadoActual .! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/14/2012 21:12'!
estasLibre

	^self estado sosLibre.! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/14/2012 21:12'!
estasPreso

	^self estado sosPreso.! !

!Participante methodsFor: 'getter' stamp: 'Federico 10/3/2012 16:43'!
estrategia
	^estrategia! !

!Participante methodsFor: 'setter' stamp: 'Federico 10/3/2012 16:43'!
estrategia: estrategiaActual
	estrategia := estrategiaActual! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/3/2012 18:13'!
hipotecaAlgunaPropiedad

	| propiedadAHipotecar |
	propiedadAHipotecar := self propiedades anyOne.
	self recibe: propiedadAHipotecar precio / 2. 
	propiedadAHipotecar sosEmpresa ifFalse: [self recibe: propiedadAHipotecar cantidadEstancias * propiedadAHipotecar costoConstruccionEstancia].
	propiedadAHipotecar hipotecate.
	
	
	! !

!Participante methodsFor: 'accessing' stamp: 'AgustinCroce 10/13/2012 16:20'!
initialize 

	self estado: Libre new.
	self cantidadDeDoble: 0.
	super initialize .! !

!Participante methodsFor: 'accessing' stamp: 'Federico 9/18/2012 10:46'!
moveteUnos: casilleros
	self avanzarPor: casilleros.
	self caerEn: casilleros last.! !

!Participante methodsFor: 'accessing' stamp: 'Federico 9/18/2012 10:41'!
paga: plata a: otroJugador 
	(self ~= otroJugador) 
		ifTrue: [self pagar: plata.
				otroJugador recibe: plata.].! !

!Participante methodsFor: 'accessing' stamp: 'Federico 9/17/2012 21:03'!
pagar: plata
	self verificaPosiblePago: plata.
	self dinero: self dinero - plata. ! !

!Participante methodsFor: 'accessing' stamp: 'AgustinCroce 10/13/2012 16:47'!
poneteLibre 
	self estado: Libre new.
	self cantidadDeDoble: 0.
	self cantidadTurnosPreso: 0.! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/3/2012 16:34'!
ponetePreso 
	self estado: Preso new.
	self cantidadDeDoble: 0.! !

!Participante methodsFor: 'getter' stamp: 'Apo 9/6/2012 17:00'!
posicionEnTablero
	^posicionEnTablero.! !

!Participante methodsFor: 'setter' stamp: 'Apo 9/6/2012 17:01'!
posicionEnTablero: posicionActual
	posicionEnTablero := posicionActual.! !

!Participante methodsFor: 'accessing' stamp: 'Apo 9/6/2012 15:42'!
recibe: unDinero 
	self dinero: self dinero + unDinero.! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/3/2012 16:10'!
sacasteDoble 
	self cantidadDeDoble: self cantidadDeDoble + 1.! !

!Participante methodsFor: 'accessing' stamp: 'AgustinCroce 10/13/2012 16:03'!
saco: unDado y: otroDado

	unDado = otroDado ifTrue: [self sacasteDoble. ] ifFalse: [self cantidadDeDoble: 0. ]   ! !

!Participante methodsFor: 'accessing' stamp: 'Federico 9/15/2012 20:13'!
teVisito: jugador en: propiedad
	| renta |
	renta := propiedad rentaPara: jugador.
	jugador pagar: renta. 
	self recibe: renta.! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/3/2012 18:02'!
tenesQueHipotecarPara: plataAPagar 
	
	self verificaPosibleHipoteca.
	self hipotecaAlgunaPropiedad.
	self dinero >= plataAPagar ifFalse: [self tenesQueHipotecarPara: plataAPagar]! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/3/2012 16:06'!
tirarDado
	^(1to: 6) atRandom.! !

!Participante methodsFor: 'accessing' stamp: 'AgustinCroce 10/13/2012 16:02'!
tirarDados
	| dado1 dado2 |
	dado1 := self tirarDado.
	dado2 := self tirarDado.
	self saco: dado1 y: dado2 .
	^dado1+ dado2.! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/3/2012 18:29'!
verificaPosibleHipoteca

	self propiedades size > 0
		ifFalse: 
			[ EstasEnBancarrotaError signal .].! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/3/2012 17:56'!
verificaPosiblePago: plata
	self dinero >= plata ifFalse: [self tenesQueHipotecarPara: plata]! !

Object subclass: #Libre
	instanceVariableNames: 'campos tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Libre methodsFor: 'as yet unclassified' stamp: 'Federico 10/3/2012 16:18'!
jugo: unJugador saco: numeroDado
	unJugador cantidadDeDoble = 2 ifTrue: [ unJugador ponetePreso .] ifFalse: [ unJugador moveteUnos: (unJugador casillerosPara: numeroDado) .]. ! !

!Libre methodsFor: 'as yet unclassified' stamp: 'Federico 10/14/2012 21:11'!
sosLibre 

	^true.! !

!Libre methodsFor: 'as yet unclassified' stamp: 'Federico 10/14/2012 21:12'!
sosPreso 

	^false.! !

Object subclass: #Preso
	instanceVariableNames: 'campos tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Preso methodsFor: 'as yet unclassified' stamp: 'Federico 10/3/2012 16:28'!
jugo: unJugador saco: numeroDado
	(unJugador cantidadDeDoble = 1) | (unJugador cantidadTurnosPreso = 3) 
		ifTrue: 
			[ unJugador poneteLibre .  
			  unJugador moveteUnos: (unJugador casillerosPara: numeroDado) .] 
		ifFalse: 
			[ unJugador cantidadTurnosPreso: unJugador cantidadTurnosPreso + 1 .].! !

!Preso methodsFor: 'as yet unclassified' stamp: 'Federico 10/14/2012 21:11'!
sosLibre 

	^false.! !

!Preso methodsFor: 'as yet unclassified' stamp: 'Federico 10/14/2012 21:11'!
sosPreso

	^true.! !

Object subclass: #Provincia
	instanceVariableNames: 'campos tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Provincia methodsFor: 'as yet unclassified' stamp: 'Federico 9/6/2012 22:09'!
agregarCampos: nuevoCampo
	campos add: nuevoCampo.! !

!Provincia methodsFor: 'getter' stamp: 'Federico 9/3/2012 21:17'!
campos
	^campos.! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Federico 9/4/2012 01:59'!
construccionParejaEn: campo
	^campos allSatisfy: [:unCampo | campo cantidadEstancias <= unCampo cantidadEstancias. ].! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Federico 9/6/2012 22:07'!
dueos
	^(campos collect: [:unCampo | unCampo dueo. ]) asSet.! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Federico 9/17/2012 21:25'!
esProvinciaMonopolica
	| dueo |
	dueo := campos first dueo.
	^campos allSatisfy: [:campo | campo dueo = dueo].! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Federico 9/6/2012 22:05'!
initialize 
	campos := OrderedCollection new.
	 ! !

!Provincia methodsFor: 'setter' stamp: 'Federico 9/17/2012 21:24'!
sePuedeConstruirEn: campo
	self verificaConstruccionEn: campo.
	^true.! !

!Provincia methodsFor: 'getter' stamp: 'Federico 9/3/2012 21:46'!
tablero
	^tablero.! !

!Provincia methodsFor: 'setter' stamp: 'Federico 9/6/2012 22:24'!
tablero: tableroActual
	tablero := tableroActual.
	tableroActual agregarProvincias: self.! !

!Provincia methodsFor: 'setter' stamp: 'AgustinCroce 10/13/2012 21:17'!
verificaConstruccionEn: campo
	(self esProvinciaMonopolica and: [ self construccionParejaEn: campo. ]) ifFalse: [NoSePuedeConstruirEstanciaError signal .].! !

Object subclass: #Standard
	instanceVariableNames: 'campos tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Standard methodsFor: 'as yet unclassified' stamp: 'Federico 10/3/2012 16:55'!
queresQue: unJugador Compre: propiedad
	^true.! !

Object subclass: #Tablero
	instanceVariableNames: 'banco casilleros provincias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Tablero methodsFor: 'as yet unclassified' stamp: 'Federico 9/6/2012 22:10'!
agregarCasilleros: casilleroNuevo
	casilleros add: casilleroNuevo.! !

!Tablero methodsFor: 'as yet unclassified' stamp: 'Federico 9/6/2012 22:10'!
agregarProvincias: nuevaProvincia
	provincias add: nuevaProvincia.! !

!Tablero methodsFor: 'getter' stamp: 'Federico 9/3/2012 21:08'!
banco
	^banco.! !

!Tablero methodsFor: 'setter' stamp: 'Federico 9/6/2012 08:33'!
banco: bancoActual
	banco := bancoActual.
	bancoActual tablero: self.! !

!Tablero methodsFor: 'getter' stamp: 'Federico 9/3/2012 21:11'!
casilleros
	^casilleros.! !

!Tablero methodsFor: 'as yet unclassified' stamp: 'Apo 9/6/2012 17:27'!
casillerosDesde: casilleroInicial hasta: unNumero
	| misCasilleros recorrido |
	misCasilleros := self casilleros copyAfter: casilleroInicial.
	recorrido := OrderedCollection new.
	[ recorrido size >= unNumero ] whileFalse: [
	misCasilleros ifEmpty: [
	misCasilleros addAll: self casilleros.
	].
	recorrido add: misCasilleros removeFirst. ].

	^recorrido.! !

!Tablero methodsFor: 'as yet unclassified' stamp: 'Federico 9/11/2012 05:20'!
initialize
	casilleros := OrderedCollection new.
	provincias := OrderedCollection new.! !

!Tablero methodsFor: 'getter' stamp: 'Federico 9/3/2012 21:48'!
provincias
	^provincias! !

Error subclass: #EstasEnBancarrotaError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

Error subclass: #NoSePuedeConstruirEstanciaError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!
